package  miss.misnonlinF;

import    jam.operator.*;
import    jam.vector.*;
import    jam.solver.*;
import  juice.operator.CompoundLinOpAdj;
import  juice.solver.*;
import  juice.vector.*;
import   rsfF.vector.*;
import   rsfF.solver.Mask;
import   rsfF.solver.SepMask;
import   conv.conviF.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Missing {
  public static void main(String[] args) {

    Rsf      datKnown = new Rsf("../Data/hole.HH");
    RsfSpace pefSpace = getPefSpace();
    InternalConvolution conv =
      new InternalConvolution(InternalConvolution.kInput,
			      (RsfSpace)  datKnown.getSpace(),
			      InternalConvolution.kFilter,
			      pefSpace                      );

    Mask pefFreeMask = getPefFreeMask(pefSpace);
    Mask datFreeMask = new SepMask(datKnown).getComplement();

    Rsf  pefKnown    = getPefKnown(pefSpace);

    hasHessian
      missDataOp = new BinaryMissingDataOp(conv,
					   datKnown, datFreeMask,
					   pefKnown, pefFreeMask);

    ProductVector x = new ProductVec(datKnown.getSpace().newMember(),
				     pefKnown.getSpace().newMember());

    Vector b = missDataOp.getRange().newMember();
    b.zero();

    Iterator iter = new IteratorSimple(10e-10F, 20, true);
    CGNonlinSolver slv = new CGNonlinSolver(x.getSpace(), b.getSpace(),
					    null, null, iter);
    // slv.setNewtonRaphsonScout();
    slv.setSecantLineScout();
    // The following parameter should be ~= # of unknowns
    slv.setFletcherReevesScout(12 + datKnown.getTotalNSamples()/3);
    slv.solve(missDataOp, b, x);

    Vector datInterp = x.getSubVector(0);
    datInterp.add(datKnown);

    Vector pefAnswer = x.getSubVector(1);
    pefAnswer.add(pefKnown);

    ((Rsf) datInterp).write("fill.H");
    ((Rsf) pefAnswer).write("filter.H");
  }

  // getPefSpace, getPefFreeMask, and getPefKnown are inter-related and
  // should be checked for mutual consistency if altered.

  static RsfSpace getPefSpace() {
    return new RsfSpace(5, 3);
  }

  static Mask getPefFreeMask(RsfSpace pefSpace) {
    Rsf freeMask = (Rsf) pefSpace.newMember();
    freeMask.fill(1F);
    freeMask.setDatum(0,0, 0F);
    freeMask.setDatum(1,0, 0F);
    freeMask.setDatum(2,0, 0F);
    return new SepMask(freeMask);
  }

  static Rsf getPefKnown(RsfSpace pefSpace) {
    Rsf pefKnown = new Rsf(pefSpace);
    pefKnown.fill(0F);
    pefKnown.setDatum(2, 0, 1F);
    return pefKnown;
  }
}
